untyped
global function autoGlitchPrecache
global function autoGlitchSettings

void function autoGlitchPrecache(){
    #if CLIENT
    AddCallback_EntitiesDidLoad(glitchAutoLight)
    thread FogDisabler()
    #endif
}

void function autoGlitchSettings(){
    #if UI
        #if S2_PLAYER_HAS_MOD_SETTINGS_GLITCH_AUTO
            AddConVarSettingEnum("glitch_oh_bloom_scale", "Bloom Scale", "S2.GlitchOverhaul | Post Processing", ["0 (Off)", "1 (Base)", "2 (Recommended)", "3 (Very High)"])
            AddConVarSettingEnum("glitch_oh_fog", "Map Fog", "S2.GlitchOverhaul | Post Processing", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_cc_toggle", "Colour Correction", "S2.GlitchOverhaul | Post Processing", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_oil_spill", "Oil Spill Lighting", "S2.GlitchOverhaul | Post Processing", ["Off", "On"])
            AddConVarSettingEnum("glitch_oh_oil_spill_shimmer", "Oil Spill Shimmer", "S2.GlitchOverhaul | Post Processing", ["Off", "On"])
            AddConVarSetting("glitch_oh_oil_spill_shimmer_speed", "Oil Spill Shimmer Speed", "S2.GlitchOverhaul | Post Processing", "float")
        #endif
    #endif
}

#if CLIENT
void function glitchAutoLight(){
    entity player = GetLocalClientPlayer()
    if(player == null)
        return
    int bloomScale = GetConVarInt("glitch_oh_bloom_scale")
    bool colourCorrectionToggle = (GetConVarInt("glitch_oh_cc_toggle") == 1)
    bool oilSpillToggle = (GetConVarInt("glitch_oh_oil_spill") == 1)
    if(GetConVarString("oldMapName") == "mp_glitch")
        player.ClientCommand("fog_enableskybox 1; mat_disable_bloom 0; fog_enable 1; mat_force_bloom 1; mat_bloom_exponent_post 1; mat_bloomscale 1; mat_bloom_wide_amount 0.2; mat_sun_scale 1; mat_sky_color 0 0 0 0; mat_colorcorrection 1; mat_envmap_scale 1.0; mat_colcorrection_disableentities 0")
    if(GetMapName() == "mp_glitch"){
        player.ClientCommand("fog_enableskybox 1; mat_disable_bloom 0; fog_enable 1; mat_force_bloom 1; mat_bloom_exponent_post 1; mat_bloomscale 3; mat_bloom_wide_amount 0.4; mat_sun_scale 0; mat_sky_color 0.1 0.15 0.2; mat_colorcorrection 1; mat_envmap_scale 0.25; mat_colcorrection_disableentities 1")
        if(bloomScale == 0)
            player.ClientCommand("mat_bloomscale 0")
        if(bloomScale == 1)
            player.ClientCommand("mat_bloom_exponent_post 1; mat_bloomscale 1; mat_bloom_wide_amount 0.2")
        if(bloomScale == 2)
            player.ClientCommand("mat_bloom_exponent_post 1; mat_bloomscale 3; mat_bloom_wide_amount 0.4")
        if(bloomScale == 3)
            player.ClientCommand("mat_bloom_exponent_post 1; mat_bloomscale 5; mat_bloom_wide_amount 0.6")
        if(!colourCorrectionToggle)
            player.ClientCommand("mat_colorcorrection 0")
        if(oilSpillToggle)
            player.ClientCommand("mat_sky_color -0.0730323 -0.572792 -2.49963")
    }
    SetConVarString("oldMapName", GetMapName())
}

void function FogDisabler(){
    bool hasOilSpill = (GetConVarInt("glitch_oh_oil_spill") == 1)
    bool hasOilSpillShimmer = (GetConVarInt("glitch_oh_oil_spill_shimmer") == 1)
    float shimmerSpeed = 0.0
    while(GetMapName() == "mp_glitch"){
        WaitFrame()
        entity player = GetLocalClientPlayer()
        if(player == null)
            continue
        if(GetConVarInt("glitch_oh_fog") == 0)
            SetMapSetting_FogEnabled(false)
        else
            SetMapSetting_FogEnabled(true)
        bool colourCorrectionToggle = (GetConVarInt("glitch_oh_cc_toggle") == 1)
        bool oilSpillToggle = (GetConVarInt("glitch_oh_oil_spill") == 1)
        bool oilSpillShimmer = (GetConVarInt("glitch_oh_oil_spill_shimmer") == 1)
        int cvar_bloomScale = GetConVarInt("mat_bloomscale")
        int bloomScale = GetConVarInt("glitch_oh_bloom_scale")
        if(bloomScale == 0 && cvar_bloomScale != 0)
            player.ClientCommand("mat_bloomscale 0")
        if(bloomScale == 1 && cvar_bloomScale != 1)
            player.ClientCommand("mat_bloom_exponent_post 1; mat_bloomscale 1; mat_bloom_wide_amount 0.2")
        if(bloomScale == 2 && cvar_bloomScale != 3)
            player.ClientCommand("mat_bloom_exponent_post 1; mat_bloomscale 3; mat_bloom_wide_amount 0.4")
        if(bloomScale == 3 && cvar_bloomScale != 5)
            player.ClientCommand("mat_bloom_exponent_post 1; mat_bloomscale 5; mat_bloom_wide_amount 0.6")
        if(!colourCorrectionToggle && GetConVarInt("mat_colorcorrection") != 0)
            player.ClientCommand("mat_colorcorrection 0")
        if(colourCorrectionToggle && GetConVarInt("mat_colorcorrection") != 1)
            player.ClientCommand("mat_colorcorrection 1")
        if(oilSpillToggle && !hasOilSpill){
            player.ClientCommand("mat_sky_color -0.0730323 -0.572792 -2.49963")
            hasOilSpill = true
            hasOilSpillShimmer = false
        }
        if(GetConVarInt("mat_colcorrection_disableentities") != 1)
            SetConVarInt("mat_colcorrection_disableentities", 1)
        if(oilSpillToggle && oilSpillShimmer){
            shimmerSpeed = GetConVarFloat("glitch_oh_oil_spill_shimmer_speed")
            vector shimmer
            shimmer.x = (-0.0730323 * (1 + (0.25 * sin((shimmerSpeed * 0.25 * Time() + 0/3) * PI * 8))))
            shimmer.y = (-0.572792 * (1 + (0.25 * sin((shimmerSpeed * 0.25 * Time() + 1/3) * PI * 4))))
            shimmer.z = (-2.49963 * (1 + (0.25 * sin((shimmerSpeed * 0.25 * Time() + 2/3) * PI * 2))))
            player.ClientCommand("mat_sky_color " + shimmer.x + " " + shimmer.y + " " + shimmer.z)
            hasOilSpill = false
            hasOilSpillShimmer = true
        }
        if(!oilSpillToggle && (hasOilSpill || hasOilSpillShimmer)){
            player.ClientCommand("mat_sky_color 0.1 0.15 0.2")
            hasOilSpill = false
            hasOilSpillShimmer = false
        }
    }
}
#endif